#!../../bin/linux-x86_64/srsCG635Test

###############################################################################
# Set up environment
epicsEnvSet("P","$(P=apexCG635:)")
epicsEnvSet("SRS_CG635_ADDRESS","$(SRS_CG635_ADDRESS=serialapex01:4004)")
epicsEnvSet("SRS_CG635_PROTOCOL","$(SRS_CG635_PROTOCOL=COM)")
< envPaths
epicsEnvSet("STREAM_PROTOCOL_PATH","${TOP}/db")
cd "${TOP}"

###############################################################################
# RegisTer all support components
dbLoadDatabase "dbd/srsCG635Test.dbd"
srsCG635Test_registerRecordDeviceDriver pdbbase

###############################################################################
# Set up ASYN port
# drvAsynIPPortConfigure port ipInfo priority noAutoconnect noProcessEos
drvAsynIPPortConfigure("L0","$(SRS_CG635_ADDRESS) $(SRS_CG635_PROTOCOL)",0,0,0)
asynSetTraceIOMask("L0",-1,0x2)
asynSetTraceMask("L0",-1,0x9)
asynSetOption("L0", -1, "baud", "9600")
asynSetOption("L0", -1, "bits", "8")
asynSetOption("L0", -1, "parity", "none")
asynSetOption("L0", -1, "stop", "1")
asynSetOption("L0", -1, "crtscts", "Y")
asynOctetSetOutputEos("L0",-1,"\r")
asynOctetSetInputEos("L0",-1,"\r")

###############################################################################
# Load record instances
dbLoadRecords("db/devsrsCG635.db", "P=$(P),R=1:,PORT=L0,A=-1")
dbLoadRecords("db/asynRecord.db", "P=$(P),R=asyn,PORT=L0,ADDR=-1,OMAX=0,IMAX=0")

###############################################################################
# Start IOC
cd ${TOP}/iocBoot/${IOC}
iocInit

