##############################################################################
# Copyright (c) 2011  Lawrence Berkeley National Laboratory, Accelerator
# Technology Group, Engineering Division
# This file is distributed subject to a Software License Agreement found
# in the file LICENSE that is included with this distribution. 
##############################################################################

#
# Very simple-minded simulation of a Stanford Research Systems CG635
#
import SocketServer
import string

class DummyCrate(SocketServer.BaseRequestHandler):
    def handle(self):
        freq = 10e6
        runState = 1
        stopLevel = 0
        cmos0Tab = [ 0.0, 0.0, 0.0, 0.0, 0.0 ]
        cmos1Tab = [ 1.2, 1.8, 2.5, 3.3, 5.0 ]
        cmosStd = 3
        cmos0 = cmos0Tab[cmosStd]
        cmos1 = cmos1Tab[cmosStd]
        qout0Tab = [ -1.00, +0.50, 1.43, 2.30, 4.00 ]
        qout1Tab = [ -1.80, -0.50, 1.07, 1.50, 3.20 ]
        qoutStd = 2
        qout0 = qout0Tab[qoutStd]
        qout1 = qout1Tab[qoutStd]
        line = ''
        while 1:
            nchar = self.request.recv(1)
            if(len(nchar) == 0):
               break
            if ((nchar == '\r') or (nchar == '\n') or (nchar == ';')):
                line.replace(string.whitespace, '')
                args = string.split(line, ',')
                cmd = ''
                val = ''
                if (len(args) >= 1):
                    if ((len(args[0]) >=5) and (args[0][4] == '?')):
                        cmd = args[0]
                    else:
                        cmd = args[0][0:4]
                        val += args[0][4:]
                if (cmd == "*IDN?"):
                    self.request.send('Stanford Research Systems,CG635,s/n004025,ver0.01\r')
                if (cmd == "TIMB?"):
                    self.request.send('0\r')

                elif (cmd == "FREQ?"):
                    self.request.send("%.12g\r" % freq)
                elif (cmd == "FREQ"):
                    freq = float(val)

                elif (cmd == "RUNS?"):
                    self.request.send("%d\r" % runState)
                elif (cmd == "RUNS"):
                    if (int(val) == 0):
                        runState = 0
                    else:
                        runState = 1

                elif (cmd == "SLVL?"):
                    self.request.send("%d\r" % stopLevel)
                elif (cmd == "SLVL"):
                    i = int(val)
                    if   (i == 0): stopLevel = 0
                    elif (i == 1): stopLevel = 1
                    elif (i == 2): stopLevel = 1 - stopLevel

                elif (cmd+val == "CMOS?0"):
                    self.request.send("%.6g\r" % cmos0)
                elif (cmd+val == "CMOS?1"):
                    self.request.send("%.6g\r" % cmos1)
                elif ((cmd+val == "CMOS0") and (len(args) == 2)):
                    cmos0 = float(args[1])
                elif ((cmd+val == "CMOS1") and (len(args) == 2)):
                    cmos1 = float(args[1])
                elif (cmd+val == "STDC?"):
                    self.request.send("%d\r" % cmosStd)
                elif (cmd == "STDC"):
                    cmosStd = int(val)
                    if ((cmosStd >= 0) and (cmosStd < len(cmos0Tab))):
                        cmos0 = cmos0Tab[cmosStd]
                        cmos1 = cmos1Tab[cmosStd]

                elif (cmd+val == "QOUT?0"):
                    self.request.send("%.6g\r" % qout0)
                elif (cmd+val == "QOUT?1"):
                    self.request.send("%.6g\r" % qout1)
                elif ((cmd+val == "QOUT0") and (len(args) == 2)):
                    qout0 = float(args[1])
                elif ((cmd+val == "QOUT1") and (len(args) == 2)):
                    qout1 = float(args[1])
                elif (cmd+val == "STDQ?"):
                    self.request.send("%d\r" % qoutStd)
                elif (cmd == "STDQ"):
                    qoutStd = int(val)
                    if ((qoutStd >= 0) and (qoutStd < len(qout0Tab))):
                        qout0 = qout0Tab[qoutStd]
                        qout1 = qout1Tab[qoutStd]

                line = ''
            elif (not nchar.isspace()):
                line += string.upper(nchar)
            cmosStd = -1
            i = 0
            while ((i < len(cmos0Tab)) and (i < len(cmos1Tab))):
                if ((cmos0 == cmos0Tab[i]) and (cmos1 == cmos1Tab[i])):
                    cmosStd = i
                    break
                i += 1
            qoutStd = -1
            i = 0
            while ((i < len(qout0Tab)) and (i < len(qout1Tab))):
                if ((qout0 == qout0Tab[i]) and (qout1 == qout1Tab[i])):
                    qoutStd = i
                    break
                i += 1

server = SocketServer.TCPServer(('', 8000), DummyCrate)
server.serve_forever()
